"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _styles = _interopRequireDefault(require("./styles"));

var _functions = require("./functions");

var _Arrow = _interopRequireDefault(require("../assets/svg/Arrow"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _readOnlyError(name) { throw new Error("\"" + name + "\" is read-only"); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

Math.easeInOutQuad = function (t, b, c, d) {
  t /= d / 2;
  if (t < 1) return c / 2 * t * t + b;
  t--;
  return -c / 2 * (t * (t - 2) - 1) + b;
};

var MunduCarousel =
/*#__PURE__*/
function (_React$Component) {
  _inherits(MunduCarousel, _React$Component);

  function MunduCarousel(props) {
    var _this;

    _classCallCheck(this, MunduCarousel);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(MunduCarousel).call(this, props));
    _this.state = {
      left: 0,
      center: 1,
      right: 2,
      currentSlidePerc: 0,
      slides: 0
    };
    _this.xDown = null;
    _this.yDown = null;
    _this.animating = false;
    _this.autoPlayTimer = null;
    return _this;
  }

  _createClass(MunduCarousel, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      window.addEventListener('touchstart', function () {
        return null;
      }, {
        passive: false
      });
      var slides = this.props.children.length;
      var left = slides - 1;
      var center = 0;
      var right = 1;

      if (slides === 1) {
        left = 0;
        center = 0;
        right = 0;
      } else if (slides === 2) {
        left = slides - 1;
        center = 0;
        right = 1;
      } else {
        left = slides - 1;
        center = 0;
        right = 1;
      }

      this.setState({
        slides: slides,
        left: left,
        center: center,
        right: right
      }, function () {
        _this2.fixStartPosition(function () {
          _this2.startAutoPlay();
        });
      });
    }
  }, {
    key: "fixStartPosition",
    value: function fixStartPosition(callback) {
      var _this$getProps = this.getProps(),
          startPosition = _this$getProps.startPosition;

      var _this$state = this.state,
          left = _this$state.left,
          center = _this$state.center,
          right = _this$state.right,
          slides = _this$state.slides;

      if (startPosition < 0 || startPosition > slides - 1) {
        console.error('Mundu Carousel: Invalid Start Position', startPosition);
        startPosition = (_readOnlyError("startPosition"), 0);
      }

      center = startPosition;
      left = startPosition - 1;
      right = startPosition + 1;

      if (left < 0) {
        left = slides - 1;
      }

      if (right > slides - 1) {
        right = 0;
      }

      this.setState({
        left: left,
        center: center,
        right: right
      }, function () {
        callback();
      });
    }
  }, {
    key: "startAutoPlay",
    value: function startAutoPlay() {
      var _this3 = this;

      var _this$getProps2 = this.getProps(),
          autoPlay = _this$getProps2.autoPlay,
          autoPlayDuration = _this$getProps2.autoPlayDuration;

      if (!autoPlay) {
        return;
      }

      clearTimeout(this.autoPlayTimer);
      this.autoPlayTimer = setTimeout(function () {
        _this3.slideRight();

        _this3.startAutoPlay();
      }, autoPlayDuration);
    }
  }, {
    key: "getTouchParams",
    value: function getTouchParams(event) {
      var carouselWrapper = this.refs.carouselWrapper;
      var carouselWidth = carouselWrapper.offsetWidth;
      var touchX = event.changedTouches[0].pageX;
      var offsetX = event.changedTouches[0].target.offsetLeft || event.changedTouches[0].target.x;
      var relativeOffset = touchX - offsetX;
      var percToMove = relativeOffset / carouselWidth * 100;
      return {
        percToMove: percToMove
      };
    }
  }, {
    key: "onTouchStart",
    value: function onTouchStart(event) {
      this.handleTouchStart(event); // const { percToMove } = this.getTouchParams(event)
    }
  }, {
    key: "onTouchMove",
    value: function onTouchMove(event) {
      this.handleTouchMove(event); // const { percToMove } = this.getTouchParams(event)
      // const currentSlidePerc = this.state.currentSlidePerc
    }
  }, {
    key: "onTouchEnd",
    value: function onTouchEnd(event) {// const { percToMove } = this.getTouchParams(event)
    }
  }, {
    key: "applyTransforms",
    value: function applyTransforms(percToMove, currentSlidePerc) {
      var _this$state2 = this.state,
          left = _this$state2.left,
          center = _this$state2.center,
          right = _this$state2.right;
      var left_slider = this.refs["slide_".concat(left)];

      if (left_slider) {
        left_slider.style.webkitTransform = "translateX(".concat(percToMove - currentSlidePerc - 100, "%)");
        left_slider.style.transform = "translateX(".concat(percToMove - currentSlidePerc - 100, "%)");
      }

      var center_slide = this.refs["slide_".concat(center)];

      if (center_slide) {
        center_slide.style.webkitTransform = "translateX(".concat(percToMove - currentSlidePerc, "%)");
        center_slide.style.transform = "translateX(".concat(percToMove - currentSlidePerc, "%)");
      }

      var right_slider = this.refs["slide_".concat(right)];

      if (right_slider) {
        right_slider.style.webkitTransform = "translateX(".concat(percToMove - currentSlidePerc + 100, "%)");
        right_slider.style.transform = "translateX(".concat(percToMove - currentSlidePerc + 100, "%)");
      }
    }
  }, {
    key: "handleTouchStart",
    value: function handleTouchStart(evt) {
      this.xDown = evt.touches[0].clientX;
      this.yDown = evt.touches[0].clientY;
    }
  }, {
    key: "handleTouchMove",
    value: function handleTouchMove(evt) {
      if (!this.xDown || !this.yDown) {
        return;
      }

      var xUp = evt.touches[0].clientX;
      var yUp = evt.touches[0].clientY;
      var xDiff = this.xDown - xUp;
      var yDiff = this.yDown - yUp;

      var _this$getProps3 = this.getProps(),
          swipePixels = _this$getProps3.swipePixels;

      if (Math.abs(xDiff) + Math.abs(yDiff) > swipePixels) {
        // to deal with to short swipes
        if (Math.abs(xDiff) > Math.abs(yDiff)) {
          /* most significant */
          if (xDiff > 0) {
            /* left swipe */
            this.slideRight();
          } else {
            /* right swipe */
            this.slideLeft();
          }

          this.startAutoPlay();
        }
        /* reset values */


        this.xDown = null;
        this.yDown = null;
      }
    }
  }, {
    key: "animateSlide",
    value: function animateSlide(direction) {
      var _this4 = this;

      var _this$getProps4 = this.getProps(),
          slideTime = _this$getProps4.slideTime;

      var to = direction == 'left' ? 100 : -100;
      var start = this.state.currentSlidePerc;
      var change = to - start;
      var currentTime = 0;
      var increment = 5;
      var self = this;

      var animateScroll = function animateScroll() {
        _this4.animating = true;
        currentTime += increment;
        var val = Math.easeInOutQuad(currentTime, start, change, slideTime);
        self.applyTransforms(val, 0);

        if (currentTime < slideTime) {
          setTimeout(animateScroll, increment);
        } else {
          self.animationEnd(direction);
          _this4.animating = false;
        }
      };

      animateScroll();
    }
  }, {
    key: "updatePositions",
    value: function updatePositions(direction) {
      if (direction === 'left') {
        this.setState({
          left: this.state.left ? --this.state.left : this.state.slides - 1,
          center: this.state.center ? --this.state.center : this.state.slides - 1,
          right: this.state.right ? --this.state.right : this.state.slides - 1
        });
      } else {
        this.setState({
          left: this.state.left < this.state.slides - 1 ? ++this.state.left : 0,
          center: this.state.center < this.state.slides - 1 ? ++this.state.center : 0,
          right: this.state.right < this.state.slides - 1 ? ++this.state.right : 0
        });
      }
    }
  }, {
    key: "animationEnd",
    value: function animationEnd(direction) {
      try {
        this.applyTransforms(0, 0);
        this.updatePositions(direction);

        var _this$getProps5 = this.getProps(),
            onSlided = _this$getProps5.onSlided;

        onSlided && onSlided(this.state.center);
      } catch (e) {
        console.error(e);
      }
    }
  }, {
    key: "slideLeft",
    value: function slideLeft() {
      var _this$getProps6 = this.getProps(),
          rotateSlides = _this$getProps6.rotateSlides;

      if (!rotateSlides && this.state.center === 0) {
        return;
      }

      !this.animating && this.animateSlide('left');
    }
  }, {
    key: "slideRight",
    value: function slideRight() {
      var _this$getProps7 = this.getProps(),
          rotateSlides = _this$getProps7.rotateSlides;

      if (!rotateSlides && this.state.right === 0) {
        return;
      }

      !this.animating && this.animateSlide('right');
    }
  }, {
    key: "slideButtons",
    value: function slideButtons(direction, event) {
      var _this5 = this;

      event.stopPropagation();
      event.preventDefault();
      this.setState({
        currentSlidePerc: 0
      }, function () {
        if (direction == 'left') {
          _this5.slideLeft();
        } else {
          _this5.slideRight();
        }

        _this5.startAutoPlay();
      });
    }
  }, {
    key: "getProps",
    value: function getProps() {
      var defaultProps = {
        width: '100%',
        maxWidth: 500,
        height: 360,
        arrows: true,
        arrowSize: 15,
        arrowColor: 'white',
        extendedStyles: null,
        className: '',
        dots: true,
        dotStyle: null,
        dotsClass: '',
        dotClass: '',
        autoPlay: true,
        autoPlayDuration: 3000,
        startPosition: 0,
        swipePixels: 50,
        slideTime: 300,
        rotateSlides: true,
        onSlided: null,
        dotsWithArrows: false
      };

      var allProps = _objectSpread({}, defaultProps, this.props);

      allProps.children = _react.default.Children.map(allProps.children, function (child, index) {
        return _react.default.cloneElement(child, {
          onClick: function onClick() {
            allProps.onClick && allProps.onClick(index);
          },
          style: {
            // copied the parent dimentions to children also
            width: allProps.width,
            maxWidth: allProps.maxWidth,
            height: allProps.height
          }
        });
      });
      return allProps;
    }
  }, {
    key: "dotClick",
    value: function dotClick(index) {
      var _this6 = this;

      var slides = this.state.slides;
      var positions = {
        left: index - 1,
        center: index,
        right: index + 1
      };
      this.setState({
        left: positions.left,
        center: positions.center,
        right: positions.right > slides - 1 ? 0 : positions.right
      }, function () {
        var _this6$getProps = _this6.getProps(),
            onSlided = _this6$getProps.onSlided;

        onSlided && onSlided(_this6.state.center);
      });
      this.startAutoPlay();
    }
  }, {
    key: "renderDots",
    value: function renderDots(_ref) {
      var _this7 = this;

      var props = _ref.props,
          dotsWithArrows = _ref.dotsWithArrows;

      var dotStyle = _objectSpread({}, _styles.default.dot, {
        backgroundColor: props.arrowColor
      });

      var center = this.state.center;
      var activeClass = 'dot active ';
      return _react.default.createElement("div", {
        style: _styles.default.dots,
        className: props.dotsClass
      }, dotsWithArrows && this.renderArrows({
        props: props,
        direction: 'left'
      }), props.children.map(function (child, index) {
        return _react.default.createElement("span", {
          className: "".concat(index === center ? activeClass : 'dot ').concat(props.dotClass),
          key: index,
          style: _objectSpread({}, dotStyle, props.dotStyle, {
            opacity: index === center ? 1 : dotStyle.opacity
          }),
          onClick: function onClick() {
            return _this7.dotClick(index);
          }
        });
      }), dotsWithArrows && this.renderArrows({
        props: props,
        direction: 'right'
      }));
    }
  }, {
    key: "renderArrows",
    value: function renderArrows(_ref2) {
      var direction = _ref2.direction,
          props = _ref2.props;

      var _this$showArrowsCheck = this.showArrowsCheck({
        props: props
      }),
          showLeftArrow = _this$showArrowsCheck.showLeftArrow,
          showRightArrow = _this$showArrowsCheck.showRightArrow;

      if (direction === 'left') {
        return _react.default.createElement("div", {
          style: props.dotsWithArrows ? _styles.default.inlineBlockArrows : _styles.default.leftArrow,
          onClick: showLeftArrow && this.slideButtons.bind(this, 'left')
        }, _react.default.createElement(_Arrow.default, {
          style: {
            visibility: showLeftArrow ? 'visible' : 'hidden'
          },
          rotate: "left",
          color: props.arrowColor,
          size: props.arrowSize
        }));
      } else {
        return _react.default.createElement("div", {
          style: props.dotsWithArrows ? _styles.default.inlineBlockArrows : _styles.default.rightArrow,
          onClick: showRightArrow && this.slideButtons.bind(this, 'right')
        }, _react.default.createElement(_Arrow.default, {
          style: {
            visibility: showRightArrow ? 'visible' : 'hidden'
          },
          rotate: "right",
          color: props.arrowColor,
          size: props.arrowSize
        }));
      }
    }
  }, {
    key: "showArrowsCheck",
    value: function showArrowsCheck(_ref3) {
      var props = _ref3.props;
      var _this$state3 = this.state,
          center = _this$state3.center,
          right = _this$state3.right;
      var showLeftArrow = props.arrows;

      if (showLeftArrow && !props.rotateSlides && center === 0) {
        showLeftArrow = false;
      }

      var showRightArrow = props.arrows;

      if (showRightArrow && !props.rotateSlides && right === 0) {
        showRightArrow = false;
      }

      return {
        showLeftArrow: showLeftArrow,
        showRightArrow: showRightArrow
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state4 = this.state,
          left = _this$state4.left,
          center = _this$state4.center,
          right = _this$state4.right;
      var props = this.getProps();

      var _this$showArrowsCheck2 = this.showArrowsCheck({
        props: props
      }),
          showLeftArrow = _this$showArrowsCheck2.showLeftArrow,
          showRightArrow = _this$showArrowsCheck2.showRightArrow;

      return _react.default.createElement("div", {
        style: _objectSpread({}, _styles.default.carouselWrapper, {
          width: props.width,
          maxWidth: props.maxWidth,
          height: props.height
        }, props.extendedStyles),
        ref: "carouselWrapper",
        onTouchStart: this.onTouchStart.bind(this),
        onTouchMove: this.onTouchMove.bind(this),
        onTouchEnd: this.onTouchEnd.bind(this),
        className: props.className
      }, _react.default.createElement("div", {
        style: _objectSpread({}, _styles.default.slideWrapper, (0, _functions.getCurrentStyle)('left')),
        key: 'left',
        ref: "slide_".concat(left)
      }, props.children[left]), _react.default.createElement("div", {
        style: _objectSpread({}, _styles.default.slideWrapper, (0, _functions.getCurrentStyle)('center')),
        key: 'center',
        ref: "slide_".concat(center)
      }, props.children[center]), _react.default.createElement("div", {
        style: _objectSpread({}, _styles.default.slideWrapper, (0, _functions.getCurrentStyle)('right')),
        key: 'right',
        ref: "slide_".concat(right)
      }, props.children[right]), props.dots && this.renderDots({
        props: props,
        dotsWithArrows: props.dotsWithArrows
      }), showLeftArrow && !props.dotsWithArrows && this.renderArrows({
        direction: 'left',
        props: props
      }), showRightArrow && !props.dotsWithArrows && this.renderArrows({
        direction: 'right',
        props: props
      }));
    }
  }]);

  return MunduCarousel;
}(_react.default.Component);

var _default = MunduCarousel;
exports.default = _default;